明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1677|回复: 5

不确定顶点数目的情况下怎么绘制多段线?

[复制链接]
发表于 2006-2-6 11:22:00 | 显示全部楼层 |阅读模式

点的数量是由变量给定,需要据此生成多端线,怎么用vba实现呢?

先谢谢了!

发表于 2006-2-6 11:32:00 | 显示全部楼层

不能先学定数目再画吗?

 楼主| 发表于 2006-2-6 14:39:00 | 显示全部楼层

想连续生成截面,每个截面复杂程度不一样啊。

发表于 2006-2-6 14:54:00 | 显示全部楼层
  1.   Dim index As Integer   
  2.     index = 2
  3.    
  4.     Dim pt1 As Variant
  5.     pt1 = ThisDrawing.Utility.GetPoint(, "输入第一点:")
  6.     If Err Then                     
  7.         Err.Clear
  8.         Exit Sub
  9.     End If
  10.     Dim ptPrevious As Variant, ptCurrent As Variant      
  11.     ptPrevious = pt1
  12.    
  13. nextpt:
  14.     ptCurrent = ThisDrawing.Utility.GetPoint(ptPrevious, "输入下一点:")
  15.     If Err Then                    
  16.         Err.Clear
  17.         Exit Sub
  18.     End If
  19.    
  20.     Dim objPline As AcadLWPolyline
  21.     If index = 2 Then
  22.         Dim points(0 To 3) As Double
  23.         points(0) = ptPrevious(0)
  24.         points(1) = ptPrevious(1)
  25.         points(2) = ptCurrent(0)
  26.         points(3) = ptCurrent(1)
  27.         Set objPline = ThisDrawing.ModelSpace.AddLightWeightPolyline(points)
  28.     ElseIf index > 2 Then
  29.         Dim ptVert(0 To 1) As Double
  30.         ptVert(0) = ptCurrent(0)
  31.         ptVert(1) = ptCurrent(1)
  32.         objPline.AddVertex index - 1, ptVert
  33.     End If
  34.     index = index + 1
  35.     ptPrevious = ptCurrent
  36.     GoTo nextpt
是不是要这样?
 楼主| 发表于 2006-2-6 15:17:00 | 显示全部楼层

嗯,就是楼上这个方法了,用不断添加点的方式实现,谢谢!

发表于 2006-2-6 21:20:00 | 显示全部楼层
为什么不用sendcommand呢?
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-27 06:28 , Processed in 0.239256 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表